package ninja.thefirearchmage.games.fourtykcalculator;

import lombok.Getter;
import ninja.thefirearchmage.games.fourtykcalculator.utils.datastructures.Tuple;
import ninja.thefirearchmage.games.fourtykcalculator.utils.datastructures.Tuple2;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static java.lang.String.format;

@Getter
public class AttackScenarioResolution {
    private Map<String, Map<WeaponStat, Object>> weaponStats;

    public AttackScenarioResolution() {
        this.weaponStats = new HashMap<>();
    }

    public void setWeaponStat(Weapon weapon, WeaponStat statName, Object statValue) {
        if(!statValue.getClass().isAssignableFrom(statName.getStatClass())) {
            throw new IllegalArgumentException(
                    format("The stat %s's value does not have the expected class %s, but instead has %s class",
                            statName.name(), statName.getStatClass().getName(), statValue.getClass().getName()));
        }

        var currentStats = weaponStats.putIfAbsent(weapon.getName(), Map.of(statName, statValue));
        if(currentStats != null) {
            currentStats.put(statName, statValue);
        }
    }
}
