package ninja.thefirearchmage.games.fourtykcalculator;

import lombok.Getter;

import java.util.Optional;

@Getter
public class DefensiveProfile {
    private final int toughness;
    private final int normalSave;
    private final int wounds;
    private final int bodies;
    private final Optional<InvulnerableSave> invulnerableSave;
    private final Optional<FeelNoPainEffect> feelNoPain;

    public DefensiveProfile(int toughness, int wounds, int bodies, int normalSave) {
        this(toughness, wounds, bodies, normalSave, Optional.empty(), Optional.empty());
    }

    public DefensiveProfile(int toughness, int wounds, int bodies, int normalSave, Optional<InvulnerableSave> invulnerableSave, Optional<FeelNoPainEffect> feelNoPain) {
        this.toughness = toughness;
        this.wounds = wounds;
        this.normalSave = normalSave;
        this.invulnerableSave = invulnerableSave;
        this.feelNoPain = feelNoPain;
        this.bodies = bodies;
    }
}
