package ninja.thefirearchmage.games.fourtykcalculator;

import org.junit.jupiter.api.Test;

import java.util.Set;

import static org.assertj.core.api.Assertions.assertThat;

class RerollTest {

    @Test
    void testFailureRerollGenerationSucceeds() {
        var successHitValue = 4;
        var failureReroll = Reroll.rerollFailures(successHitValue);
        var expectedRerollableValues = Set.of(1,2,3);
        assertThat(failureReroll.getRerollableValues()).isEqualTo(expectedRerollableValues);
    }

    @Test
    void testRerollOnes() {
        var rerollOnes = Reroll.rerollOnOnes();
        var expectedRerollableValues = Set.of(1);
        assertThat(rerollOnes.getRerollableValues()).isEqualTo(expectedRerollableValues);
    }

    @Test
    void testFishingFives() {
        var rerollToFishFives = Reroll.rerollOnNot(Set.of(5,6));
        var expectedRerollableValues = Set.of(1,2,3,4);
        assertThat(rerollToFishFives.getRerollableValues()).isEqualTo(expectedRerollableValues);
    }
}
